
//  KalentereitaApplet.java  (c) Kari Laitinen

//  http://www.naturalprogramming.com/

//  2009-02-12  Tiedosto luotu.
//  2009-02-12  Viimeisin muutos.

//  Tm ohjelma tulostaa muutamia kalentereita, eli tm
//  on Applet-versio komentoriviohjelmasta Kalentereita.java.

//  Knnksen aikana tiedostojen Paivamaara.java ja PaivienEtaisyys.java
//  tulee olla samassa hakemistossa (kansiossa) tmn ohjelman kanssa.

import java.awt.* ;

class  SuomalainenKalenteri
{
   protected  int  tama_kuukausi ;
   protected  int  tama_vuosi ;

   protected  int  kalenterin_paikka_x ;  //  Tarkoitta paikkaa jonne
   protected  int  kalenterin_paikka_y ;  //  kalenteri piirretn nytll.

   protected  String[]  kuukausien_nimet ;
   protected  String    viikon_kuvaus ;

   public SuomalainenKalenteri() {}

   public SuomalainenKalenteri( int annettu_vuosi,
                                int annettu_kuukausi,
                                int annettu_paikka_x,
                                int annettu_paikka_y  )
   {
      tama_vuosi     =  annettu_vuosi  ;
      tama_kuukausi  =  annettu_kuukausi ;

      kalenterin_paikka_x  =  annettu_paikka_x ;
      kalenterin_paikka_y  =  annettu_paikka_y ;

      String[]  suomalaiset_kuukausien_nimet  =  

         { "Tammikuu", "Helmikuu", "Maaliskuu", "Huhtikuu",
           "Toukokuu", "Kesakuu",  "Heinakuu",  "Elokuu",
           "Syyskuu",  "Lokakuu",  "Marraskuu", "Joulukuu" } ;

      String  suomalainen_viikon_kuvaus  =

          "Viikko   Ma   Ti   Ke   To   Pe   La   Su" ;

      kuukausien_nimet   =  suomalaiset_kuukausien_nimet ;

      viikon_kuvaus  =  suomalainen_viikon_kuvaus ;
   }


   // Seuraavalla metodilla voidaan muuttaa paikkaa jonne
   // kalenteri piirretn ruudulla.

   public void aseta_kalenterin_paikka( int annettu_paikka_x,
                                        int annettu_paikka_y )
   {
      kalenterin_paikka_x  =  annettu_paikka_x ;
      kalenterin_paikka_y  =  annettu_paikka_y ;
   }

   public void piirra( Graphics graphics )
   {
      Paivamaara  paiva_tassa_kuussa  = 
                     new  Paivamaara( 1, tama_kuukausi, tama_vuosi ) ;

      int viikonpaivan_indeksi   =  0 ;
      int ensimmaisen_paivan_viikonpaiva  =
                          paiva_tassa_kuussa.viikonpaivan_indeksi() ;

      int rivilaskuri = 0 ;

      graphics.drawString(  "   "  +  kuukausien_nimet[ tama_kuukausi - 1 ]
                         +  "  "  +  tama_vuosi,
                            kalenterin_paikka_x,
                            kalenterin_paikka_y  ) ;

      graphics.drawString( viikon_kuvaus,
                           kalenterin_paikka_x,
                           kalenterin_paikka_y + 20 ) ;


      String kalenterin_rivi =  String.format(
                    "%4d  ",  paiva_tassa_kuussa.laske_viikkonumero() ) ; 

      //  Ensimmainen kuukauden viikko on usein epataydellinen viikko,
      //  eli viikon alkupaivat kuuluvat edelliseen kuukauteen.
      //  Edelliseen kuukauteen kuuluvien paivien tilalle
      //  tulostetaan valilyonteja.

      while ( viikonpaivan_indeksi  !=  ensimmaisen_paivan_viikonpaiva )
      {
         kalenterin_rivi = kalenterin_rivi + "     "  ;
         viikonpaivan_indeksi  ++ ;
      }

      while ( tama_kuukausi  ==  paiva_tassa_kuussa.kuukausi() )
      {
         if ( viikonpaivan_indeksi  >=  7 )
         {
            //  Tulostetaan nykyinen kalenterin rivi

            graphics.drawString( kalenterin_rivi,
                                 kalenterin_paikka_x,
                                 kalenterin_paikka_y +
                                    40 +  rivilaskuri * 20  ) ;

            rivilaskuri ++ ;

            //  Otetaan uusi rivi kyttn

            kalenterin_rivi =  String.format(
                    "%4d  ",  paiva_tassa_kuussa.laske_viikkonumero() ) ; 

            viikonpaivan_indeksi  =  0 ;
         }

         kalenterin_rivi =  kalenterin_rivi
                          + String.format( "%5d", paiva_tassa_kuussa.paiva() ) ;

         paiva_tassa_kuussa.kasvata() ;

         viikonpaivan_indeksi  ++  ;
      }

      if ( kalenterin_rivi.length() > 6 )
      {
         // Tulostetaan viimeinen rivi.

         graphics.drawString( kalenterin_rivi,
                              kalenterin_paikka_x,
                              kalenterin_paikka_y +
                                    40 +  rivilaskuri * 20  ) ;

      }
   }
}



class  EspanjalainenKalenteri  extends  SuomalainenKalenteri
{
   public EspanjalainenKalenteri( int annettu_vuosi,
                                  int annettu_kuukausi,
                                  int annettu_paikka_x,
                                  int annettu_paikka_y  )
   {
      tama_vuosi     =  annettu_vuosi  ;
      tama_kuukausi  =  annettu_kuukausi ;

      kalenterin_paikka_x  =  annettu_paikka_x ;
      kalenterin_paikka_y  =  annettu_paikka_y ;

      String[]  espanjalaiset_kuukausien_nimet  =

         { "Enero", "Febrero", "Marzo", "Abril",
           "Mayo", "Junio", "Julio", "Agosto",
           "Septiembre", "Octubre", "Noviembre", "Deciembre" } ;

      String   espanjalainen_viikon_kuvaus  =

           "Semana  Lun  Mar  Mie  Jue  Vie  Sab  Dom" ;

      kuukausien_nimet  =  espanjalaiset_kuukausien_nimet ;
      viikon_kuvaus     =  espanjalainen_viikon_kuvaus ;
   }
}



public class KalentereitaApplet extends javax.swing.JApplet
{
   int apletin_leveys, apletin_korkeus ;

   public void init()
   {
      apletin_leveys   =  getSize().width ;
      apletin_korkeus  =  getSize().height ;
   }

   public void paint( Graphics graphics )
   {
      super.paint( graphics ) ;

      //  Fontin pit olla "monospaced" eli kaikkien kirjainten
      //  ja merkkien samanlevyisi. Piirrettvn kalenterin
      //  ulkomuoto perustuu thn.

      graphics.setFont( new Font( "monospaced", Font.BOLD, 12 ) ) ;

      SuomalainenKalenteri  eras_suomalainen_kalenteri  =
                              new  SuomalainenKalenteri( 2009, 4, 120,  50 ) ;

      eras_suomalainen_kalenteri.piirra( graphics ) ;

      SuomalainenKalenteri  toinen_suomalainen_kalenteri  =
                              new  SuomalainenKalenteri( 2009, 5, 120, 220 ) ;

      toinen_suomalainen_kalenteri.piirra( graphics ) ;

      EspanjalainenKalenteri eras_espanjalainen_kalenteri  =
                              new  EspanjalainenKalenteri( 2009, 6, 120, 380 ) ;

      eras_espanjalainen_kalenteri.piirra( graphics ) ;
   }
}





